//= require anchorific
//= require resizable

$(function() {

  $('.ae-sidebar-right').resizable({
    handles: 'w',
    minWidth: 100,
    maxWidth: $('.ae-sidebar-right').parent().width() * 0.4,
    containment: '.ae-template-master-detail-fixed',
    resize: function(event, ui){
      var siblingMain = ui.element.siblings('.ae-content')
      var siblingSidebar = ui.element.siblings('.ae-sidebar')
      var parent = ui.element.parent()
      ui.size.height = ui.originalSize.height
      siblingMain.width(parent.width() - (siblingSidebar.width() + ui.size.width) - 100)
    },
    stop: function(event, ui){
      ui.element.css('left', '')
    }
  });

  $(".js-anchorific-content").anchorific({
    headers: ':header:not(.ae-demo-container :header, h4)'
  });

  $(".anchorific li").each(function(index, item) {
    $(item).has("ul").addClass("collapsed");
  });

  $('.anchorific li').on('click', function(e){

    $selectedLink = $(e.target)
    $selectedLinkTitle = $selectedLink.closest('li[data-tag]');

    if ($selectedLinkTitle.find("ul").length > 0) {
      $selectedLinkTitle.children('ul').toggle();
      $selectedLinkTitle.toggleClass("collapsed expanded");
      e.preventDefault();
      e.stopPropagation();
      return;
    }

    // TODO: Sidebar scripts in mobile that need to be moved to its proper JS folder
    if ($(window).width() < 768) {
      $('.js-ae-sidebar').hide();
    }

    $('html, body').animate({
        scrollTop: $('[id="' + $.attr($selectedLink.closest('a')[0], 'href').substr(1) + '"]').offset().top - $(".ae-header-fixed").height()
    }, 500);
    return false;
  });

  $('body').append("<a href='#' class='ae-btn ae-btn-secondary ae-btn-sm back-to-top'>Back to top &nbsp;<i class='fa fa-long-arrow-up'></i></a>");
  $('.back-to-top').css('display', 'none')

  $(window).scroll(function() {
    if ($(this).scrollTop() >= 100) {        // If page is scrolled more than 100px
        $('.back-to-top').fadeIn(200);    // Fade in the arrow
      } else {
        $('.back-to-top').fadeOut(100);   // Else fade out the arrow
      }
    });

  $('.back-to-top').click(function() {
    $("html, body").animate({ scrollTop: 0 }, "slow");
    return false;
  });


  //demo tabs
  $('.ae-demo-container').on('click', '.ae-tab', function(e){
    $clickedTab = $(this)
    $parentContainer = $clickedTab.parents('.ae-demo-container')
    tabContent = $clickedTab.data('tab')

    $parentContainer.find('.ae-tab.active-tab').removeClass('active-tab')
    $clickedTab.addClass('active-tab')
    $parentContainer.find('.ae-tab-content.active-tab').removeClass('active-tab')
    $parentContainer.find('#' + tabContent).addClass('active-tab');
    $('.ae-calendar').fullCalendar('render');
  });
});



