module ExpressUi
  module ApplicationHelper
    include ChecksForTesting

    def nav_link_to(text, path)
      class_name = current_page?(path) ? 'ae-nav-item active' : 'ae-nav-item'

      content_tag :li, class: class_name do
        link_to text, path
      end
    end

    def highlight_code_block(&block)
      code_block = capture(&block)

      code_block_in_code_element = code_block_in_code_element(code_block)

      content_tag :pre do
        code_block_in_code_element
      end
    end

    def code_block_in_code_element(code_block)
      content_tag :code, class: "ae-code-block prettyprint" do
        code_block.strip_heredoc.html_safe
      end
    end

    # This only works for controllers within this engine. (eg test/dummy)
    # Put this method in your application_helper.rb and
    # customize it to your purpose.
    def user_role_classes
      return "role-user" if defined?(current_user) && current_user.present?
    end
  end
end
