module ExpressUi
  class Engine < ::Rails::Engine
    require 'jquery-rails'
    require 'font-awesome-sass'
    require 'fullcalendar-rails'
    require 'select2-rails'
    require 'magnific-popup-rails'
    require 'momentjs-rails'

    isolate_namespace ExpressUi

    initializer :assets do |config|
      Rails.application.config.assets.precompile << /\.(?:svg|eot|woff|ttf|png|jpg|jpeg|gif)$/
      Rails.application.config.assets.precompile += %w( express_ui/styleguide.css )
      Rails.application.config.assets.precompile += %w(
        appexpress/express_admin.svg
        appexpress/express_api.svg
        appexpress/express_auth.svg
        appexpress/express_billing.svg
        appexpress/express_dashboard.svg
        appexpress/express_data.svg
        appexpress/express_media.svg
        appexpress/express_pages.svg
        appexpress/express_rbac.svg
        appexpress/express_report.svg
        appexpress/express_seo.svg
      )
    end
  end
end
